package ood.dbc;

/**
 * An assertion in the system
 */
public interface Assertion {

  /**
   * Pass the checked object to the assertion class.
   * Ensured to be called before any other method of the assertion class.
   * @param obj the checked object.
   */
  public void setObject(Object obj);

  /**
   * Checks the object's invariant.
   * @return true if the object's invariant is correct, false otherwise. 
   */
  public boolean invariant();

}