package samples.math;

/**
 * Similar to the java.lang.Double, but only with positive (&gt;=0)
 * values.
 */
public interface PositiveDouble {

	/**
	 * Sets the value of the object.
	 * @param val the new value of the object.
	 */
	public void setValue(double val);

	/**
	 * Returns the value of the object. 
	 * @return the value of the object.
	 */
	public double getValue();

	/**
	 * Returns the square root of the object.
	 * @return the square root of the object.
	 */
	public double getSqrt();

	/**
	 * Returns the sum of the object's value and the given parameter.
	 * @param e the addition to the object's value
	 * @return the sum of the object's value and the given parameter.
	 */
	public double getSum(double e);

	/**
	 * Adds the given value to the object's value.
	 * @param e the addition to the object's value
	 */
	public void add(double e);

}
