package samples.math.impl;

import samples.math.PositiveDouble;

/**
 * A simple implementation of the PositiveDouble interface.
 */
public class PositiveDoubleImpl implements PositiveDouble {
	
	/**
	 * The object's value
	 */
	private double d;

	/**
	 * Sets the value of the object.
	 * @param val the new value of the object.
	 * @see samples.math.PositioveDouble#setValue(double)
	 */
	public void setValue(double val) {
		d = val;
	}
	
	/**
	 * Returns the value of the object. 
	 * @return the value of the object.
	 * @see samples.math.PositioveDouble#getValue()
	 */
	public double getValue() {
		return d;
	}
	
	/**
	 * Returns the square root of the object.
	 * @return the square root of the object.
	 * @see samples.math.PositioveDouble#getSqrt()
	 */
	public double getSqrt() {
		return Math.sqrt(d);
	}
	
	/**
	 * Returns the sum of the object's value and the given parameter.
	 * @param e the addition to the object's value
	 * @return the sum of the object's value and the given parameter.
	 * @see samples.math.PositioveDouble#getSum(double)
	 */
	public double getSum(double e) {
		return d + e;
	}
	
	/**
	 * Adds the given value to the object's value.
	 * @param e the addition to the object's value
	 * @see samples.math.PositioveDouble#add(double)
	 */
	public void add(double e) {
		d += e;
	}
}
