package samples.shapes.impl;

import samples.shapes.Circle;
import samples.shapes.Position;

/**
 * 
 */
public class CircleImpl implements Circle {

	/**
	 * The center of the circle
	 */
	private Position center;

	/**
	 * The radius of the circle
	 */
	private double radius;

	/**
	 * Creates new CircleImpl instance, located at the default 
	 * position with radius of zero.
	 */
	public CircleImpl() {
		this(new Position(), 0.0);
	}
	
	/**
	 * Creates new CircleImpl instance, located at the give
	 * position with the given radius.
	 * @param center a Position object represents the circle's center.
	 * @param radius a double represents the circle's radius.
	 */
	public CircleImpl(Position center, double radius) {
		setCenter(center);
		setRadius(radius);
	}

	/* (non-Javadoc)
	 * @see shapes.Circle#getCenter()
	 */
	public Position getCenter() {
		return this.center;
	}

	/* (non-Javadoc)
	 * @see shapes.Circle#setCenter(shapes.Position)
	 */
	public void setCenter(Position center) {
		this.center = center;
	}

	/* (non-Javadoc)
	 * @see shapes.Circle#getRadius()
	 */
	public double getRadius() {
		return this.radius;
	}

	/* (non-Javadoc)
	 * @see shapes.Circle#setRadius(double)
	 */
	public void setRadius(double radius) {
		this.radius = radius;
	}

	/* (non-Javadoc)
	 * @see shapes.Shape#getArea()
	 */
	public double getArea() {
		return 4.0 * Math.PI * getRadius() * getRadius();
	}

	/* (non-Javadoc)
	 * @see shapes.Shape#getPerimeter()
	 */
	public double getPerimeter() {
		return 2.0 * Math.PI * getRadius();
	}

}
