/*
 * Created on Jun 3, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package samples.shapes.impl;

import samples.shapes.Position;
import samples.shapes.Rectangle;

/**
 * @author dar
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class RectangleImpl implements Rectangle {

	/**
	 * The bottom left corner of the rectangle
	 */
	private Position bottomLeftCorner;

	/**
	 * The width of the rectangle
	 */
	private double width;

	/**
	 * The height of the rectangle
	 */
	private double height;

	/**
	 * Creates new instance located at the default position
	 * with zero width and height. 
	 */
	public RectangleImpl() {
		this(new Position(), 0.0, 0.0);
	}
	
	/**
	 * Creates new instance located at the given position
	 * with the given width and height. 
	 * @param bottomLeftCorner a Position object represents the 
	 *                         bottom left corner of the rectangle
	 * @param width            a double represents the width of the 
	 *                         rectangle
	 * @param height           a double represents the height of the 
	 *                         rectangle
	 */
	public RectangleImpl(
		Position bottomLeftCorner,
		double width,
		double height) {
		setBottomLeftCorner(bottomLeftCorner);
		setWidth(width);
		setHeight(height);
	}

	/* (non-Javadoc)
	 * @see shapes.Rectangle#getTopRightCorner()
	 */
	public Position getBottomLeftCorner() {
		return this.bottomLeftCorner;
	}

	/* (non-Javadoc)
	 * @see shapes.Rectangle#setTopRightCorner(shapes.Position)
	 */
	public void setBottomLeftCorner(Position pos) {
		this.bottomLeftCorner = pos;
	}

	/* (non-Javadoc)
	 * @see shapes.Rectangle#getWidth()
	 */
	public double getWidth() {
		return this.width;
	}

	/* (non-Javadoc)
	 * @see shapes.Rectangle#setWidth(double)
	 */
	public void setWidth(double width) {
		this.width = width;
	}

	/* (non-Javadoc)
	 * @see shapes.Rectangle#getHeight()
	 */
	public double getHeight() {
		return this.height;
	}

	/* (non-Javadoc)
	 * @see shapes.Rectangle#setHeight(double)
	 */
	public void setHeight(double height) {
		this.height = height;
	}

	/* (non-Javadoc)
	 * @see shapes.Shape#getArea()
	 */
	public double getArea() {
		return getWidth() * getHeight();
	}

	/* (non-Javadoc)
	 * @see shapes.Shape#getPerimeter()
	 */
	public double getPerimeter() {
		return 2.0 * (getWidth() + getHeight());
	}

}
